package bst;

/**
 * @author Aapo Kyrola, Sulake Corporation 2008
 */


import org.junit.Test;
import org.junit.Before;import static org.junit.Assert.assertEquals;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.Collections;

import static java.lang.Math.*;

public class BinarySearchTreeTest {

    private Comparator<String> comp;
    private BinarySearchTree<String, String> bst;

    @Before
    public void setup() {
        comp = new Comparator<String>() {
            public int compare(String s, String s1) {
                return s.compareTo(s1);
            }
        };
        bst = new BinarySearchTree<String, String>(comp);

        addValue("aabraham");
        addValue("juho");        
        addValue("aapo");
        addValue("timo");
        addValue("waltteri");
        addValue("is");
        addValue("iti");

        System.out.println("Max depth: " + bst.getMaxDepth());
        System.out.println("Size: " + bst.size());

        bst.printTree();
    }

    private void addValue(String s) {
        bst.insert(s, s.toUpperCase());
    }




    @Test
    public void testSearch() {
       assertEquals(bst.search("aapo"), "AAPO");
       assertEquals(bst.search("iti"), "ITI");
       assertEquals(bst.search("waltteri"), "WALTTERI");
    }

}
