package bst.demo;

import bst.BinarySearchTree;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * User: akyrola
 * Date: 3/5/12; time: 10:30 AM
 * Carnegie Mellon Univ, 2012
 */
public class BSTPanel extends JPanel {

    BinarySearchTree<Integer, JButton> bst;

    int[] levelcounts;

    public BSTPanel(BinarySearchTree<Integer,JButton> bst) {
        this.bst = bst;
        this.setLayout(null);
        setSize(1000,500);
        refresh();
        setVisible(true);

        System.out.println("Max depth:" + bst.getMaxDepth());
    }

    public Dimension getPreferredSize() {
        return new Dimension(1000, 500);
    }

    public void paintComponent(Graphics g) {
        super.paintComponent(g);
    }

    public int space(int depth) {
        int maxdepth = bst.getMaxDepth();
        if (maxdepth > 5) maxdepth = 5;
        int spc =  (1+maxdepth-depth) * (800 / (1<<maxdepth)) / (1<<depth);
        if (spc < 20) spc = 20;
        return spc;
    }

    void refresh() {
        levelcounts = new int[256]; //dirty
        draw(bst.getRoot(), 0, 400);
    }

    private void draw(final BinarySearchTree<Integer,JButton>.Node node, int depth, int x) {
        if (node == null) return;

        int y = 30 + depth * 25;

        System.out.println("Add node: " + node + " to " + x + "," + y);


        node.getValue().setBounds(x - 30, y, 22, 20);
        if (node.getValue().getParent() == null)  {
            this.add(node.getValue());
            node.getValue().addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    bst.splay(node);
                    System.out.println("Splayed!");
                    refresh();
                }});
        }
        draw(node.getLeft(), depth+1, x-space(depth));
        draw(node.getRight(), depth + 1, x+space(depth));
    }
}
